# Image v2 Commands

## image member

### image add project

Associate project with image

    openstack image add project
        [--project-domain <project-domain>]
        <image>
        <project>

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

image

  Image to share (name or ID)

project

  Project to associate with image (ID)

### image remove project

Disassociate project with image

    openstack image remove project
        [--project-domain <project-domain>]
        <image>
        <project>

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

image

  Image to unshare (name or ID)

project

  Project to disassociate with image (name or ID)

### image member list

List projects associated with image

    openstack image member list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--project-domain <project-domain>]
        <image>

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

image

  Image (name or ID)

### image member get

Show a particular project associated with image

    openstack image member get
        [--project-domain <project-domain>]
        <image>
        <project>

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

image

  Image (name or ID)

project

  Project to show (name or ID)

## image metadef

### image metadef namespace create

Create a metadef namespace

    openstack image metadef namespace create
        [--display-name <display_name>]
        [--description <description>]
        [--public | --private]
        [--protected | --unprotected]
        <namespace>

--display-name <display_name>

  A user-friendly name for the namespace.

--description <description>

  A description of the namespace

--public

  Set namespace visibility ‘public’

--private

  Set namespace visibility ‘private’

--protected

  Prevent metadef namespace from being deleted

--unprotected

  Allow metadef namespace to be deleted (default)

namespace

  New metadef namespace name

### image metadef namespace delete

Delete metadef namespace

    openstack image metadef namespace delete <namespace> [<namespace> ...]

namespace

  Metadef namespace(s) to delete (name)

### image metadef namespace list

List metadef namespaces

    openstack image metadef namespace list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--resource-types <resource_types>]
        [--visibility <visibility>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--resource-types <resource_types>

  filter resource types

--visibility <visibility>

  filter on visibility

### image metadef namespace set

Set metadef namespace properties

    openstack image metadef namespace set
        [--display-name <display_name>]
        [--description <description>]
        [--public | --private]
        [--protected | --unprotected]
        [--tag <tag>]
        <namespace>

--display-name <display_name>

  Set a user-friendly name for the namespace.

--description <description>

  Set the description of the namespace

--public

  Metadef namespace is accessible to the public

--private

  Metadef namespace is inaccessible to the public (default)

--protected

  Prevent metadef namespace from being deleted

--unprotected

  Allow metadef namespace to be deleted (default)

--tag <tag>

  Set a tag on this metadef namespace (repeat option to set multiple tags)

namespace

  Metadef namespace to modify (name)

### image metadef namespace show

Show a metadef namespace

    openstack image metadef namespace show <namespace>

namespace

  Metadef namespace to show (name)

### image metadef resource type list

List metadef resource types

    openstack image metadef resource type list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

### image metadef object create

Create a metadef object

    openstack image metadef object create
        [--namespace <namespace>]
        <metadef-object-name>

--namespace <namespace>

  Metadef namespace to create the object in (name)

metadef-object-name

  New metadef object name

### image metadef object show

Show a particular metadef object

    openstack image metadef object show <namespace> <object>

namespace

  Metadef namespace of the object (name)

object

  Metadef object to show

### image metadef object list

List metadef objects inside a specific namespace.

    openstack image metadef object list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        <namespace>

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

namespace

  Namespace (name) for the namespace

### image metadef object delete

Delete metadata definitions object(s)

    openstack image metadef object delete <namespace> [<object> ...]

namespace

  Metadef namespace of the object (name)

object

  Metadef object(s) to delete (name) (omit this argument to delete all objects in the namespace)

### image metadef object update

Update a metadef object

    openstack image metadef object update
        [--name NAME]
        <namespace>
        <object>

--name <NAME>

  New name of the object

namespace

  Metadef namespace name

object

  Metadef object to be updated

### image metadef object property show

Describe a specific metadata definitions property inside an object.

    openstack image metadef object property show
        <namespace_name>
        <object_name>
        property

namespace_name

  Namespace (name) for the namespace

object_name

  Name of an object.

property

  Name of the property.

### image metadef property create

Create a metadef property

    openstack image metadef property create
        --name NAME
        --title TITLE
        --type TYPE
        --schema SCHEMA
        namespace

--name <NAME>

  Internal name of the property

--title <TITLE>

  Property name displayed to the user

--type <TYPE>

  Property type

--schema <SCHEMA>

  Valid JSON schema of the property

namespace

  Name of namespace the property will belong.

### image metadef property list

List metadef properties

    openstack image metadef property list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        <namespace>

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

namespace

  An identifier (a name) for the namespace

### image metadef property show

Show a particular metadef property

    openstack image metadef property show <namespace> <property>

namespace

  Metadef namespace of the property (name)

property

  Property to show

### image metadef property delete

Delete metadef propert(ies)

    openstack image metadef property delete <namespace> [<property> ...]

namespace

  Metadef namespace of the property (name)

property

  Metadef properties to delete (name) (omit this argument to delete all properties in the namespace)

### image metadef property set

Update metadef namespace property

    openstack image metadef property set
        [--name NAME]
        [--title TITLE]
        [--type TYPE]
        [--schema SCHEMA]
        namespace
        property

--name <NAME>

  Internal name of the property

--title <TITLE>

  Property name displayed to the user

--type <TYPE>

  Property type

--schema <SCHEMA>

  Valid JSON schema of the property

namespace

  Namespace of the namespace to which the property belongs

property

  Property to update

### image metadef namespace unset

Unset metadef namespace tags

    openstack image metadef namespace unset
        (--tag <tag> | --all-tags)
        <namespace>

--tag <tag>

  Unset a tag on this metadef namespace (repeat option to unset multiple tags)

--all-tags

  Unset all metadef tags

namespace

  Metadef namespace to modify (name)

### image metadef resource type association create

Create metadef resource type association

    openstack image metadef resource type association create
        [--properties-target <properties_target>]
        <namespace>
        <name>

--properties-target <properties_target>

  Some resource types allow more than one key/value pair per instance.

namespace

  The name of the namespace you want to create the resource type association in

name

  A name of the new resource type

### image metadef resource type association delete

Delete metadef resource type association

    openstack image metadef resource type association delete
        [--force]
        <metadef_namespace>
        <name>
        [<name> ...]

--force

  Force delete the resource type association if thenamespace is protected

metadef_namespace

  The name of the namespace whose details you want to see

name

  The name of the resource type(s) (repeat option to deletemultiple metadef resource type associations)

### image metadef resource type association list

List metadef resource type associations

    openstack image metadef resource type association list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        <metadef_namespace>

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

metadef_namespace

  The name of the namespace whose details you want to see

## image task

### image task list

List tasks

    openstack image task list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--sort-key <key>[:<field>]]
        [--sort-dir <key>[:<direction>]]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]
        [--type <type>]
        [--status <status>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--sort-key <key>[:<field>]

  Sorts the response by one of the following attributes: created_at, expires_at, id, status, type, updated_at. (default is created_at) (multiple keys and directions can be specified separated by comma)

--sort-dir <key>[:<direction>]

  Sort output by selected keys and directions (asc or desc) (default: name:desc) (multiple keys and directions can be specified separated by comma)

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

--type <type>

  Filters the response by a task type.

--status <status>

  Filter tasks based on status.

### image task show

Display task details

    openstack image task show <Task ID>

Task ID

  Task to display (ID)

## image

### image create

Create/upload an image

    openstack image create
        [--id <id>]
        [--container-format <container-format>]
        [--disk-format <disk-format>]
        [--min-disk <disk-gb>]
        [--min-ram <ram-mb>]
        [--file <file> | --volume <volume>]
        [--force]
        [--progress]
        [--sign-key-path <sign-key-path>]
        [--sign-cert-id <sign-cert-id>]
        [--protected
        |
        --unprotected
        ]
        [--public
        |
        --private
        |
        --community
        |
        --shared
        ]
        [--property <key=value>]
        [--tag <tag>]
        [--project <project>]
        [--import]
        [--project-domain <project-domain>]
        <image-name>

--id <id>

  Image ID to reserve

--container-format <container-format>

  Image container format. The supported options are: ami, ari, aki, bare, docker, ova, ovf. The default format is: bare

--disk-format <disk-format>

  Image disk format. The supported options are: ami, ari, aki, vhd, vmdk, raw, qcow2, vhdx, vdi, iso, ploop. The default format is: raw

--min-disk <disk-gb>

  Minimum disk size needed to boot image, in gigabytes

--min-ram <ram-mb>

  Minimum RAM size needed to boot image, in megabytes

--file <file>

  Upload image from local file

--volume <volume>

  Create image from a volume

--force

  Force image creation if volume is in use (only meaningful with –volume)

--progress

  Show upload progress bar (ignored if passing data via stdin)

--sign-key-path <sign-key-path>

  Sign the image using the specified private key. Only use in combination with –sign-cert-id

--sign-cert-id <sign-cert-id>

  The specified certificate UUID is a reference to the certificate in the key manager that corresponds to the public key and is used for signature validation. Only use in combination with –sign-key-path

--protected

  Prevent image from being deleted

--unprotected

  Allow image to be deleted (default)

--public

  Image is accessible and visible to all users

--private

  Image is only accessible by the owner (default until –os-image-api-version 2.5)

--community

  Image is accessible by all users but does not appear in the default image list of any user except the owner (requires –os-image-api-version 2.5 or later)

--shared

  Image is only accessible by the owner and image members (requires –os-image-api-version 2.5 or later) (default since –os-image-api-version 2.5)

--property <key=value>

  Set a property on this image (repeat option to set multiple properties)

--tag <tag>

  Set a tag on this image (repeat option to set multiple tags)

--project <project>

  Set an alternate project on this image (name or ID)

--import

  Force the use of glance image import instead of direct upload

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

image-name

  New image name

### image delete

Delete image(s)

    openstack image delete [--store <STORE>] <image> [<image> ...]

--store <STORE>

  Store to delete image(s) from.

image

  Image(s) to delete (name or ID)

### image list

List available images

    openstack image list
        [--sort-column SORT_COLUMN]
        [--sort-ascending
        |
        --sort-descending
        ]
        [--public
        |
        --private
        |
        --community
        |
        --shared
        |
        --all
        ]
        [--property <key=value>]
        [--name <name>]
        [--status <status>]
        [--member-status <member-status>]
        [--project <project>]
        [--project-domain <project-domain>]
        [--tag <tag>]
        [--hidden]
        [--long]
        [--sort <key>[:<direction>]]
        [--limit <limit>]
        [--marker <marker>]
        [--max-items <max-items>]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--public

  List only public images

--private

  List only private images

--community

  List only community images (requires –os-image-api-version 2.5 or later)

--shared

  List only shared images (requires –os-image-api-version 2.5 or later)

--all

  List all images

--property <key=value>

  Filter output based on property (repeat option to filter on multiple properties)

--name <name>

  Filter images based on name.

--status <status>

  Filter images based on status.

--member-status <member-status>

  Filter images based on member status. The supported options are: accepted, pending, rejected, all.

--project <project>

  Search by project (admin only) (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--tag <tag>

  Filter images based on tag. (repeat option to filter on multiple tags)

--hidden

  List hidden images

--long

  List additional fields in output

--sort <key>[:<direction>]

  Sort output by selected keys and directions (asc or desc) (default: name:asc), multiple keys and directions can be specified separated by comma

--limit <limit>

  The maximum number of entries to return per page. If the value exceeds the server-defined maximum, then the server-defined value will be used. Note that this controls the page size, not the total number of entries returned. Use –max-items to limit the total number of entries returned.

--marker <marker>

  The first position in the collection to return results from. This should be a value that was returned in a previous request.

--max-items <max-items>

  The maximum number of entries to return in total, paging through multiple requests if needed. Use –limit to control the page size.

### image save

Save an image locally

    openstack image save
        [--chunk-size <chunk-size>]
        [--file <filename>]
        <image>

--chunk-size <chunk-size>

  Size in bytes to read from the wire and buffer at one time (default: 1024)

--file <filename>

  Downloaded image save filename (default: stdout)

image

  Image to save (name or ID)

### image set

Set image properties

    openstack image set
        [--name <name>]
        [--min-disk <disk-gb>]
        [--min-ram <ram-mb>]
        [--container-format <container-format>]
        [--disk-format <disk-format>]
        [--protected
        |
        --unprotected
        ]
        [--public
        |
        --private
        |
        --community
        |
        --shared
        ]
        [--property <key=value>]
        [--tag <tag>]
        [--architecture <architecture>]
        [--instance-id <instance-id>]
        [--kernel-id <kernel-id>]
        [--os-distro <os-distro>]
        [--os-version <os-version>]
        [--ramdisk-id <ramdisk-id>]
        [--deactivate
        |
        --activate
        ]
        [--project <project>]
        [--project-domain <project-domain>]
        [--accept
        |
        --reject
        |
        --pending
        ]
        [--hidden | --unhidden]
        <image>

--name <name>

  New image name

--min-disk <disk-gb>

  Minimum disk size needed to boot image, in gigabytes

--min-ram <ram-mb>

  Minimum RAM size needed to boot image, in megabytes

--container-format <container-format>

  Image container format. The supported options are: ami, ari, aki, bare, docker, ova, ovf

--disk-format <disk-format>

  Image disk format. The supported options are: ami, ari, aki, vhd, vmdk, raw, qcow2, vhdx, vdi, iso, ploop

--protected

  Prevent image from being deleted

--unprotected

  Allow image to be deleted (default)

--public

  Image is accessible and visible to all users

--private

  Image is only accessible by the owner (default until –os-image-api-version 2.5)

--community

  Image is accessible by all users but does not appear in the default image list of any user except the owner (requires –os-image-api-version 2.5 or later)

--shared

  Image is only accessible by the owner and image members (requires –os-image-api-version 2.5 or later) (default since –os-image-api-version 2.5)

--property <key=value>

  Set a property on this image (repeat option to set multiple properties)

--tag <tag>

  Set a tag on this image (repeat option to set multiple tags)

--architecture <architecture>

  Operating system architecture

--instance-id <instance-id>

  ID of server instance used to create this image

--kernel-id <kernel-id>

  ID of kernel image used to boot this disk image

--os-distro <os-distro>

  Operating system distribution name

--os-version <os-version>

  Operating system distribution version

--ramdisk-id <ramdisk-id>

  ID of ramdisk image used to boot this disk image

--deactivate

  Deactivate the image

--activate

  Activate the image

--project <project>

  Set an alternate project on this image (name or ID)

--project-domain <project-domain>

  Domain the project belongs to (name or ID). This can be used in case collisions between project names exist.

--accept

  Accept the image membership for either the project indicated by ‘–project’, if provided, or the current user’s project

--reject

  Reject the image membership for either the project indicated by ‘–project’, if provided, or the current user’s project

--pending

  Reset the image membership to ‘pending’

--hidden

  Hide the image

--unhidden

  Unhide the image

image

  Image to modify (name or ID)

### image unset

Unset image tags and properties

    openstack image unset [--tag <tag>] [--property <property-key>] <image>

--tag <tag>

  Unset a tag on this image (repeat option to unset multiple tags)

--property <property-key>

  Unset a property on this image (repeat option to unset multiple properties)

image

  Image to modify (name or ID)

### image show

Display image details

    openstack image show [--human-readable] <image>

--human-readable

  Print image size in a human-friendly format.

image

  Image to display (name or ID)

### image stage

Upload data for a specific image to staging. This requires support for the interoperable image import process, which was first introduced in Image API version 2.6 (Glance 16.0.0 (Queens))

    openstack image stage [--file <file>] [--progress] <image>

--file <file>

  Local file that contains disk image to be uploaded. Alternatively, images can be passed via stdin.

--progress

  Show upload progress bar (ignored if passing data via stdin)

image

  Image to upload data for (name or ID)

### image import

Initiate the image import process. This requires support for the interoperable image import process, which was first introduced in Image API version 2.6 (Glance 16.0.0 (Queens))

    openstack image import
        [--method <method>]
        [--uri <uri>]
        [--remote-image <REMOTE_IMAGE>]
        [--remote-region <REMOTE_GLANCE_REGION>]
        [--remote-service-interface <REMOTE_SERVICE_INTERFACE>]
        [--store [<STORE> ...]
        |
        --all-stores
        ]
        [--allow-failure | --disallow-failure]
        [--wait]
        <image>

--method <method>

  Import method used for image import process. Not all deployments will support all methods. The ‘glance-direct’ method (default) requires images be first staged using the ‘image-stage’ command.

--uri <uri>

  URI to download the external image (only valid with the ‘web-download’ import method)

--remote-image <REMOTE_IMAGE>

  The image of remote glance (ID only) to be imported (only valid with the ‘glance-download’ import method)

--remote-region <REMOTE_GLANCE_REGION>

  The remote Glance region to download the image from (only valid with the ‘glance-download’ import method)

--remote-service-interface <REMOTE_SERVICE_INTERFACE>

  The remote Glance service interface to use when importing images (only valid with the ‘glance-download’ import method)

--store <STORE>

  Backend store to upload image to (specify multiple times to upload to multiple stores) (either ‘–store’ or ‘–all-stores’ required with the ‘copy-image’ import method)

--all-stores

  Make image available to all stores (either ‘–store’ or ‘–all-stores’ required with the ‘copy-image’ import method)

--allow-failure

  When uploading to multiple stores, indicate that the import should be continue should any of the uploads fail. Only usable with –stores or –all-stores

--disallow-failure

  When uploading to multiple stores, indicate that the import should be reverted should any of the uploads fail. Only usable with –stores or –all-stores

--wait

  Wait for operation to complete

image

  Image to initiate import process for (name or ID)

## image import info

Show available import methods

    openstack image import info

## image stores

### image stores list

Get available backends (only valid with Multi-Backend support)

    openstack image stores list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]
        [--detail]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

--detail

  Shows details of stores (admin only) (requires –os-image-api-version 2.15 or later)

## cached image

### cached image list

Get Cache State

    openstack cached image list
        [--sort-column SORT_COLUMN]
        [--sort-ascending | --sort-descending]

--sort-column SORT_COLUMN

  specify the column(s) to sort the data (columns specified first have a priority, non-existing columns are ignored), can be repeated

--sort-ascending

  sort the column(s) in ascending order

--sort-descending

  sort the column(s) in descending order

### cached image queue

Queue image(s) for caching.

    openstack cached image queue <image> [<image> ...]

image

  Image to display (name or ID)

### cached image delete

Delete image(s) from cache

    openstack cached image delete <image> [<image> ...]

image

  Image(s) to delete (name or ID)

### cached image clear

Clear all images from cache, queue or both

    openstack cached image clear [--cache] [--queue]

--cache

  Clears all the cached images

--queue

  Clears all the queued images

this page last updated: 2026-07-15 15:33:41

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.